
/*************** AVAIL Set for color availability ****************
	Availability for this program is implemented
	as bit vectors, with bit i representing color i.

 ********************************************/


extern void PushAvail(int v, int depth);

int	avail[MAXVERTEX],	/* avail list - a bit vector for each vertex! */
	numavail[SMALLVECTOR];	/* equal to number of available colors */
void setcount()
/*
        set numavail[i] = to number of 1 bits in i
*/
{
        int i,j;
        for(i=0;i<SMALLVECTOR;i++) {
                numavail[i]=0;
                for(j=1;j<SMALLVECTOR;j<<=1) numavail[i] += (0 != (j&i));
        }
} /* end setcount */

void initavail(int targetcolor)
/*
	Initialize available colors for each vertex
*/
{
	int i,k;
	k = (1<<targetcolor) - 1;
	for (i=0;i<order;i++) 
		avail[i] = k;
} /* end initavail */

void PrintAvail(int k, int targetcolor)
{
	int i;
	for(i=targetcolor-1;i>=0;i--)
		if (avail[k] & (1<<i)) 
			printf("1"); 
		else	printf("0");
} /* end PrintAvail */

int RemoveAvail(int av,  	/* colors to be removed */
		int w,		/* vertex to reduce coloring of */
		settype s1,	/* the three activity sets */
		settype s2,
		settype s3,
		int depth,	/* depth at which occurred */
		int rtype)	/* for recording new stats */
/* 
	remove the cvolors in av from the avail set of w
	return NO if numavail[avail[w]] goes to zero
	else return YES
*/
{
	int i;
	/* if none to delete return */
	if ( !(av & avail[w]) ) return YES;

	
	if (numavail[avail[w]] <= 3) {
		Delete(s1,w); /* do all to be sure -? */
#ifdef PROPTWO
		Delete(s2,w);
#ifdef PROPTHREE
		Delete(s3,w);
#endif
#endif
	}
	PushAvail(w,depth);

	i =0;
	while (i<targetcolor) {
		if (avail[w] & av & (1<<i)) {
			numremoved[rtype][depth]++; /* record stats */
		}
		i++;
	}
	avail[w] &= ~av;

	if (0==numavail[avail[w]]) {
		numfailed[rtype][depth]++; /* record stats*/
		return NO;
	}
	if (1 == numavail[avail[w]]) {
		AddOne(s1,w);
		numforced[rtype][depth]++; /*record stats*/
		totalnumcolored++; /* record stats*/
	}
#ifdef PROPTWO
	else if(2 == numavail[avail[w]])
		AddOne(s2,w);
#ifdef PROPTHREE
	else if (3==numavail[avail[w]])
		AddOne(s3,w);
#endif
#endif
	return YES;
} /* end RemoveAvail */

/************** end AVAILSet for color availability ***********/
