/************** Restore and color as final step ****************/
void RestoreAndColor(adjlist G,int targetcolor)
{
	int i,x,y;
	int lastv;
	enum action type;

	lastv = -1;
	
	PopChange(G, &x,&y,&type);
	while ( nop != type ) {
		switch (type) {
		 case delv : 
#ifdef STACKTRACE
			printf("POP DeleteV %d ",x+1);
			printf("avail[%d] =",x+1);
			PrintAvail(x,targetcolor);
			printf(" lastv = %d avail = ",lastv+1);
			PrintAvail(lastv,targetcolor);
			printf("\n");
#endif
			/* make sure last vertex colored */
			if (lastv != -1) {
				i=0;
				while (numavail[avail[lastv]] > 1 ) {
					avail[lastv] &= ~(1<<i);
					i++;
				}
			}
			/* restore vertex */
			lastv = x;
			AddOne(G->vlist,x);
			break;

		case dele :
#ifdef STACKTRACE
			printf("POP DeleteE %d %d ",x+1,y+1);
			printf("avail[%d]= ",x+1);
			PrintAvail(x,targetcolor);
			printf(" avail[%d]= ",y+1);
			PrintAvail(y,targetcolor);
			printf("\n");
#endif
			/* restore edge */
			AddOne(G->nbrlist[x],y);
			AddOne(G->nbrlist[y],x);

			/* check colors */
			if (numavail[avail[x]] == 1 ) 
				avail[y] &= ~avail[x];
			if (numavail[avail[y]] == 1 ) 
				avail[x] &= ~avail[y];

			if ( (numavail[avail[x]] == 0) 
			   || (numavail[avail[y]] == 0) ) {
				printf("ERROR: RestoreAndColor coloring fails here\n");
				exit(1);
			}
			break;

		case adde :
#ifdef STACKTRACE
			printf("POP AddE %d %d\n",x+1,y+1);
#endif
			Delete(G->nbrlist[x],y);
			Delete(G->nbrlist[y],x);
			break;

		case merg :
#ifdef STACKTRACE
			printf("POP Merge %d %d\n",x+1,y+1);
			printf("avail[%d] = ",x+1);
			PrintAvail(x,targetcolor);
			printf(" avail[%d] = ",y+1);
			PrintAvail(y,targetcolor);
			printf(" lastv = %d avail = ",lastv+1);
			PrintAvail(lastv,targetcolor);
			printf("\n");
#endif
			/* make sure last vertex colored */
			if (lastv != -1) {
				i=0;
				while (numavail[avail[lastv]] > 1 ) {
					avail[lastv] &= ~(1<<i);
					i++;
				}
			}
			lastv = x;
			if (numavail[avail[y]] != 1) {
				printf("ERROR avail[%d] = ",y);
				PrintAvail(y,targetcolor);
				printf("\n");
				exit(1);
			}
			if ( ! (avail[x] & avail[y] ) ) {
				printf("ERROR %d does not have color of %d\n",
					x,y);
				exit(1);
			}
			avail[x] = avail[y];

			/* restore vertex */
			AddOne(G->vlist,x);
			
			break;

		case nop :
			printf("NOP (should not print)\n\n");
			break;
		default :
			printf("ERROR Illegal op type from change stack\n");
			exit(1);
		}
		PopChange(G, &x, &y, &type);
	}

} /* end RestoreAndColor */

/********** Final step ends of Restore and Color from graph stack *******/
