/*********** STACKS for AVAIL and REDUCTION Restoration ********/
typedef struct _availstack{
	int *vertex;
	int *avail;
	int *depth;
	int top;
}	availstack;

/* we need one of these  for availability */
availstack astack;



void InitAvailStack(int targetcolor)
/*
	Each vertex should not appear more than once for each possible
	reduction
*/
{

	astack.vertex = (int *) calloc(targetcolor*order, sizeof(int));
	astack.avail = (int *) calloc(targetcolor*order, sizeof(int));
	astack.depth = (int *) calloc(targetcolor*order, sizeof(int));
	astack.top =0;
	astack.depth[astack.top] = -1; /* dummy end of stack */
} /* end InitAvailStack */

void RemoveAvailStack()
{
        free(astack.vertex);
        free(astack.avail);
        free(astack.depth);
} /* end RemoveAvailStack */

void PushAvail(int v, /* vertex to push */
		int depth) /* record depth for correct restoration */
{
	astack.top++;
	astack.vertex[astack.top] = v;
	astack.avail[astack.top] = avail[v];
	astack.depth[astack.top] = depth;
} /* end PushAvail */


/***********END STACKS ***********************/
